# Hashes
mohs = {
  "talc"     => 1,
  "calcite"  => 3,
  "apatite"  => 5,
  "corundum" => 9,
}
typeof(mohs) # => Hash(String, Int32)

mohs["apatite"] # => 5

mohs["gold"]
# => Runtime error: Missing hash key: "gold" (KeyError)

mohs["gold"]? # => nil

mohs.has_key? "gold" # => false

mohs["diamond"] = 9  # adding key
mohs["diamond"] = 10 # changing value
mohs
# => {"talc" => 1, "calcite" => 3, "apatite" => 5,
#    "corundum" => 9, "diamond" => 10}
mohs.size # => 5

mohs['C'] = 4.5 # Error: no overload matches
# 'Hash(String, Int32)#[]=' with types Char, Float64

# creating an empty hash:
mohs = {}    # Error: Syntax error: for empty hashes use
# '{} of KeyType => ValueType'

mohs = {} of String => Int32 # {}
mohs = Hash(String, Int32).new
