#---
# Excerpted from "Programming Crystal",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/crystal for more book information.
#---

class Mineral
  attr_reader :name, :hardness, :crystal_struct

  def initialize(name, hardness, crystal_struct)
    @name = name
    @hardness = hardness
    @crystal_struct = crystal_struct
  end
end

def mineral_with_crystal_struct(crstruct, minerals)
  minerals.find { |m| m.crystal_struct == crstruct }
end

def longest_name(minerals)
  minerals.map { |m| m.name }.max_by { |name| name.size }
end

minerals = [ 
  Mineral.new("gold", 1, 'cubic'),
  Mineral.new("topaz", 8, 'orthorombic'),
  Mineral.new("apatite", 5, 'hexagonal'),
  Mineral.new("wolframite", 4.5, 'monoclinic'),
  Mineral.new("calcite", 3, 'trigonal'),
  Mineral.new("diamond", 10, 'cubic'),
]

min = mineral_with_crystal_struct('hexagonal', minerals)
puts "#{min.crystal_struct} - #{min.name} - #{min.hardness}"
# => hexagonal - apatite - 5

puts longest_name(minerals)
# => wolframite

# Runtime error:
min = mineral_with_crystal_struct('triclinic', minerals)
puts "#{min.crystal_struct} - #{min.name} - #{min.hardness}"
# 3.5_mineral.rb:39:in `<main>': undefined method 'crystal_struct' 
# for nil:NilClass (NoMethodError)

# $ time ruby 3.5_mineral.rb  # => real 0.087 s

