str = "What a beautiful mineral!"
str1 = "What a
          beautiful mineral!" # multi-line string

ch = 'C'     # (1)
ch == "C"    # (2) => false
typeof(ch)   # (3) => Char
typeof("C")  # => String
typeof(Char) # => Class
!true        # (4) => false

ch = 42
typeof(ch) # => Int32

a = 42_i64
f = 1.5e-10
typeof(f) # => Float64

puts a1 # => Error: undefined local variable or method 'a1'
b : Int32
puts b

a1 : String

a1 : String = "hello"
a1 = 42 # => Error: type must be String, not (Int32 | String)

str.size # => 25
ch.size  # => Error: undefined method 'size' on Int32"

ch + str # => Error: no overload matches 'Int32#+' with type String
# Overloads are:
#  - Int32#+(other : Int8)
#  - Int32#+(other : Int16)
#  - Int32#+(other : Int32)
#  - Int32#+(other : Int64)
#  - Int32#+(other : UInt8)
#  - Int32#+(other : UInt16)
#  - Int32#+(other : UInt32)
#  - Int32#+(other : UInt64)
#  - Int32#+(other : Float32)
#  - Int32#+(other : Float64)
#  - Number#+()

str, num = "Diamond", 42
str # => "Diamond"
num # => 42

# swap
n = 41
m = 42
n, m = m, n
n # => 42
m # => 41

# multiple statements on one line
n = 3; n += 1; p n # => 4

n = begin
  a = 3
  a += 1
  a
end # => 4

# string interpolation
"The sum = #{41 + 2.5}" # => "The sum = 43.5"

s1 = "Cry"
s2 = "stal"
less_good = s1 + s2   # => "Crystal"
better = "#{s1}#{s2}" # => "Crystal"

GRAVC = 6.67e-11 # gravitational constant
GRAVC =        5 # => Error: already initialized constant

nil         # => nil
typeof(nil) # => Nil
