# Arrays
minerals = ["alunite", "chromium", "vlasovite"]
typeof(minerals) # => Array(String)

# or, to use a different notation
minerals2 = %w(alunite chromium vlasovite)
typeof(minerals2) # => Array(String)

minerals << "wagnerite"
minerals << "muscovite"
minerals 
# => ["alunite", "chromium", "vlasovite", "wagnerite", "muscovite"]
minerals.size # => 5


minerals << 42 
# => Error: no overload matches 'Array(String)#<<' with type Int32

precious_minerals = [] 
# => Error: for empty arrays use '[] of ElementType'

precious_minerals = [] of String
precious_minerals2 = Array(String).new


# indexing
minerals[0]  # => "alunite"
minerals[3]  # => "wagnerite"
minerals[-2] # => "wagnerite"
# negative indices count from the end, which is -1

minerals[2, 3] # => ["vlasovite", "wagnerite", "muscovite"]
minerals[2..4] # => ["vlasovite", "wagnerite", "muscovite"]

minerals[7] # => Runtime error: Index out of bounds (IndexError)

minerals[7]? # => nil

pseudo_minerals = ["alunite", 'C', 42]

typeof(pseudo_minerals) # => Array(Char | Int32 | String)
