hardness = 7  # quartz

if hardness < 8
   puts "softer than topaz"
end
# => softer than topaz

hardness = 5.25
if 0 < hardness < 5
  puts "softer than apatite"
elsif hardness < 8
  puts "harder than apatite, softer than topaz"
else
  puts "topaz or harder!"
end
# => harder than apatite, softer than topaz

# if as an expression
output = if 0 < hardness < 5
           "softer than apatite"
         elsif hardness < 8
           "harder than apatite, softer than topaz"
         else
           "topaz or harder!"
         end
output # => harder than apatite, softer than topaz

# if as a suffix
output = "softer than topaz" if hardness < 8 # => softer than topaz

# unless
output = "softer than topaz" unless hardness >= 8
output # => softer than topaz

# case
output = case hardness
         when 4
           "hard as fluorite"
         when 7
           "hard as quartz"
         when 10
           "hard as diamond"
         else
           "can't say how hard"
         end # => "can't say how hard"

output = case
         when 0 < hardness < 5
           "softer than apatite"
         when hardness < 8
           "harder than apatite, softer than topaz"
         else
           "topaz or harder!"
         end # => harder than apatite, softer than topaz"

# simple loops:
# Int#times
5.times do
  p "Hi"
  p "Low"
end
# same as:
5.times { p "Hi"; p "Low" }

# Range#each
mohs_list = ["nothing", "talc", "gypsum", "calcite", "fluorite", "apatite",
"orthoclase feldspar", "quartz", "topaz", "corundum", "diamond"]
(2..5).each do |i|
   puts mohs_list[i]
end
# produces:
# gypsum
# calcite
# fluorite
# apatite

# Range#each
mohs_list = ["nothing", "talc", "gypsum", "calcite", "fluorite", "apatite",
  "orthoclase feldspar", "quartz", "topaz", "corundum", "diamond"]
mohs_list.each do |mineral|
  puts mineral
end
# produces:
# nothing
# talc
# gypsum
# calcite
# fluorite
# apatite
# orthoclase feldspar
# quartz
# topaz
# corundum
# diamond

# infinite loop with break:
n = 1
loop do
  puts "a mighty crystal"
  n += 1
  break if n == 3
end
# => a mighty crystal
# => a mighty crystal

# while
a = 1
while (a += 1) < 10
  if a == 3
    next
  elsif a > 6
    break
  end
  puts a
end # => 2, 4, 5 and 6 on successive lines


inc = 2..7
p inc.to_a  #=> [2, 3, 4, 5, 6, 7]
exc = 2...7
p exc.to_a  #=> [2, 3, 4, 5, 6]
