base = "USD"
rates = {
  "EUR" => 0.84320536,
  "CAD" => 1.26761115,
  "CNY" => 6.61591576,
}
full_names = {
  "EUR" => "Euro",
  "CAD" => "Canadian Dollar",
  "CNY" => "Chinese Yuan",
}

# How much is 1 US Dollar?
output = "1 #{base} = \n" +  # (1)
         rates.keys.map do |curr|  # (2)
           "\t#{rates[curr]} #{full_names[curr]}s (#{curr})"
         end.join("\n")  # (3)
puts output
# 1 USD =
#     0.84320536 Euros (EUR)
#     1.26761115 Canadian Dollars (CAD)
#     6.61591576 Chinese Yuans (CNY)

puts
# How much is 42 US Dollars?
amount = 42
output = "#{amount} #{base} = \n" +
         rates.keys.map do |curr|
           temp = sprintf("%3.2f", amount * rates[curr]) # (4)
           "\t#{temp} #{full_names[curr]}s (#{curr})"
         end.join("\n")
puts output
# 42 USD =
#      35.41 Euros (EUR)
#      53.24 Canadian Dollars (CAD)
#      277.87 Chinese Yuans (CNY)
