result = (42..47).to_a                          # (1) => [42, 43, 44, 45, 46, 47]
           .sort { |n, m| m <=> n }             # (2) => [47, 46, 45, 44, 43, 42]
           .reject { |n| n.odd? }               # (3) => [46, 44, 42]
           .map { |n| n * n }                   # (4) => [2116, 1936, 1764]
           .select { |n| n % 4 == 0 }           # (5) => [2116, 1936, 1764]
           .tap { |arr| puts "#{arr.inspect}" } # (6) => [2116, 1936, 1764]
           .sort!                               # (7) => [1764, 1936, 2116]
           .any? { |num| num > 2000 }           # (8) => true

sum = (42..47).to_a
              .reduce(0) { |sum, num| sum + num } 
              # => 267 (= 42 + 43 +... + 47)
