curr1 = "US Dollar"
curr1[2..4]                      # => " Do"
curr1.reverse                    # => "ralloD SU"
curr1.size                       # => 9   # length or len do not exist
curr1.upcase                     # => "US DOLLAR"
curr1.capitalize                 # => "Us dollar"
curr1.includes? "la"             # => true
curr1.count "l"                  # => 2
curr1.starts_with? "Us"          # => false # case sensitive!
curr1.ends_with? "ar"            # => true
curr1.index("a")                 # => 7
curr1.sub("ll", "l")             # => "US Dolar"  
curr1.gsub(/([aeiou])/, "*\\1*") # => "US D*o*ll*a*r"
curr2 = curr1.split("")          # => ["U","S"," ","D","o","l","l","a","r"]
curr2.join("-")                  # => "U-S- -D-o-l-l-a-r"

s = "USD"
s[2] = 's' # => Error: undefined method '[]=' for String

rate = 0.84320536
p "rate: " + rate.to_s # => "rate: 0.84320536" # creates a string on the heap!
# better:
p "rate:  #{rate}" # => "rate:  0.84320536"
# best:
str = String.build do |io|
  io << "rate: " << rate
end
p str # => "rate:  0.84320536"
