# code that can give a nil pointer exception
# because connection can be closed, --> gets returns nil
require "socket"

server = TCPServer.new(8080) # (1)
socket = server.accept       # (2)
puts socket.gets.upcase      # (3)
# Error: => undefined method 'upcase' for nil
# compile-time type is (String | Nil)

# Solution:
line = socket.gets
if line
  puts line.capitalize # Crystal knows that line cannot be nil here!
else
  puts "Nothing in the socket"
end
